> ## Documentation Index
> Fetch the complete documentation index at: https://docs.polymorfa.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List phone numbers

> **Protocols:** Linked Device API · Meta Cloud API

**Required scope:** `sessions:read`



## OpenAPI

````yaml api-reference/features/waba-features-graph.json GET /graph/whatsapp/{version}/{wabaId}/phone_numbers
openapi: 3.0.3
info:
  title: WABA features Polymorfa Graph API methods
  version: 1.0.0
  description: Task-focused waba features methods exposed by the Polymorfa Graph API.
servers: []
security: []
paths:
  /graph/whatsapp/{version}/{wabaId}/phone_numbers:
    get:
      tags:
        - Phone numbers
      summary: List phone numbers
      description: |-
        **Protocols:** Linked Device API · Meta Cloud API

        **Required scope:** `sessions:read`
      operationId: graphListPhoneNumbers
      parameters:
        - schema:
            type: string
            example: v21.0
          required: true
          name: version
          in: path
          description: Specifies version for this path parameter.
        - schema:
            type: string
            example: '200000000000001'
          required: true
          name: wabaId
          in: path
          description: Identifier for the waba.
      responses:
        '200':
          description: Phone numbers
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/graph__GraphPhoneNumbersResponse'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/graph__GraphError'
        '401':
          description: Unauthenticated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/graph__GraphError'
        '403':
          description: Permission error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/graph__GraphError'
        '404':
          description: Object does not exist
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/graph__GraphError'
        '429':
          description: Rate limited
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/graph__GraphError'
        '500':
          description: Internal error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/graph__GraphError'
      security:
        - graph__BearerAuth: []
      servers:
        - url: https://api.polymorfa.com
components:
  schemas:
    graph__GraphPhoneNumbersResponse:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/graph__GraphPhoneNumber'
          description: Structured data carried by this object.
      required:
        - data
    graph__GraphError:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              description: Human-readable message associated with this result.
            type:
              type: string
              description: Type discriminator for this object.
            code:
              type: number
              description: Stable machine-readable code for this result.
            error_subcode:
              type: number
              description: Machine-readable error subcode for this error.
            error_data:
              nullable: true
              description: |-
                Specifies error data for this error.

                <!-- polymorfa-input-table -->
                **Accepted alternatives**
                | Alternative | Accepted input |
                | --- | --- |
                | Alternative 1 | Any JSON value matching this alternative |
                | Alternative 2 | `null` |
            fbtrace_id:
              type: string
              description: Identifier for the fbtrace.
          required:
            - message
            - type
            - code
            - fbtrace_id
          description: Error details returned when the operation fails.
      required:
        - error
    graph__GraphPhoneNumber:
      type: object
      properties:
        id:
          type: string
          description: Identifier for this resource.
        display_phone_number:
          type: string
          description: Specifies display phone number for this graph graph phone number.
        verified_name:
          type: string
          description: Human-readable verified name for this graph graph phone number.
        code_verification_status:
          type: string
          description: >-
            Specifies code verification status for this graph graph phone
            number.
        quality_rating:
          type: string
          description: Specifies quality rating for this graph graph phone number.
        platform_type:
          type: string
          description: Category assigned to platform.
        throughput:
          type: object
          properties:
            level:
              type: string
              description: Specifies level for this throughput.
          required:
            - level
          description: Structured throughput values for this graph graph phone number.
      required:
        - id
        - display_phone_number
        - verified_name
        - code_verification_status
        - quality_rating
        - platform_type
        - throughput
  securitySchemes:
    graph__BearerAuth:
      type: http
      scheme: bearer
      description: >-
        Polymorfa organization key (pmfa_ prefix) or project token (pmfa_pt_
        prefix). Client tokens are not accepted by Graph operations.

````